<?php

namespace Drupal\pdftemplate\Controller;

use Drupal\Core\Controller\ControllerBase;
use Drupal\Core\Entity\EntityTypeManagerInterface;
use PDFTemplate\PDFTemplate;
use Symfony\Component\DependencyInjection\ContainerInterface;

/**
 * Returns responses for PDFTemplate routes.
 */
class TestController extends ControllerBase {

  /**
   * The entity type manager.
   *
   * @var \Drupal\Core\Entity\EntityTypeManagerInterface
   */
  protected $entityTypeManager;

  /**
   * The controller constructor.
   *
   * @param \Drupal\Core\Entity\EntityTypeManagerInterface $entity_type_manager
   *   The entity type manager.
   */
  public function __construct(EntityTypeManagerInterface $entity_type_manager) {
    $this->entityTypeManager = $entity_type_manager;
  }

  /**
   * {@inheritdoc}
   */
  public static function create(ContainerInterface $container) {
    return new static(
      $container->get('entity_type.manager')
    );
  }

  /**
   * Builds the response.
   */
  public function build() {
    $template_id = \Drupal::routeMatch()->getParameter('pdftemplate');
    $template = $this->entityTypeManager->getStorage('pdftemplate')->load($template_id);
    $uri = $template->get('template')->entity->getFileUri();

    $pdf = new PDFTemplate();
    $pdf->setFilename('test.pdf');
    $pdf->setTemplate($uri);
    $pdf->setDestination('temporary://test.pdf');

    $pdf->addVar('TITLE', 'test');

    $file = $pdf->createPDF();
    header('Content-type: application/pdf');
    header('Content-disposition: attachment; filename="test.pdf"');
    readfile('temporary://test.pdf');
    exit();

    $build['content'] = [
      '#type' => 'item',
      '#markup' => $this->t('It works!'),
    ];
    return $build;
  }

}
