<?php

namespace Drupal\pdftemplate\Form;

use Drupal\Core\Entity\ContentEntityForm;
use Drupal\Core\Form\FormStateInterface;

/**
 * Form controller for the pdftemplate entity edit forms.
 */
class PDFTemplateForm extends ContentEntityForm {

  /**
   * {@inheritdoc}
   */
  public function save(array $form, FormStateInterface $form_state) {

    $entity = $this->getEntity();
    $result = $entity->save();
    $link = $entity->toLink($this->t('View'))->toRenderable();

    $message_arguments = ['%label' => $this->entity->label()];
    $logger_arguments = $message_arguments + ['link' => render($link)];

    if ($result == SAVED_NEW) {
      $this->messenger()->addStatus($this->t('New pdftemplate %label has been created.', $message_arguments));
      $this->logger('pdftemplate')->notice('Created new pdftemplate %label', $logger_arguments);
    }
    else {
      $this->messenger()->addStatus($this->t('The pdftemplate %label has been updated.', $message_arguments));
      $this->logger('pdftemplate')->notice('Updated new pdftemplate %label.', $logger_arguments);
    }

    $form_state->setRedirect('entity.pdftemplate.canonical', ['pdftemplate' => $entity->id()]);
  }

}
