<?php

namespace Drupal\pdftemplate;

use Drupal\Core\Entity\ContentEntityInterface;
use Drupal\Core\Entity\EntityChangedInterface;

/**
 * Provides an interface defining a pdftemplate entity type.
 */
interface PDFTemplateInterface extends ContentEntityInterface, EntityChangedInterface {

  /**
   * Gets the pdftemplate name.
   *
   * @return string
   *   Title of the pdftemplate.
   */
  public function getName();

  /**
   * Sets the pdftemplate name.
   *
   * @param string $name
   *   The pdftemplate name.
   *
   * @return \Drupal\pdftemplate\PDFTemplateInterface
   *   The called pdftemplate entity.
   */
  public function setName($name);

  /**
   * Gets the pdftemplate variables.
   *
   * @return array
   *   Array of variables.
   */
  public function getVariables();

  /**
   * Sets the pdftemplate variables.
   *
   * @param array $variables
     The pdftemplate variables.
   *
   * @return \Drupal\pdftemplate\PDFTemplateInterface
   *   The called pdftemplate entity.
   */
  public function setVariables($variables);

  /**
   * Gets the pdftemplate creation timestamp.
   *
   * @return int
   *   Creation timestamp of the pdftemplate.
   */
  public function getCreatedTime();

  /**
   * Sets the pdftemplate creation timestamp.
   *
   * @param int $timestamp
   *   The pdftemplate creation timestamp.
   *
   * @return \Drupal\pdftemplate\PDFTemplateInterface
   *   The called pdftemplate entity.
   */
  public function setCreatedTime($timestamp);

}
